ICU 56.1: icu::RuleBasedBreakIterator Class Reference

ICU 56.1 56.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Friends
icu::RuleBasedBreakIterator Class Reference

A subclass of BreakIterator whose behavior is specified using a list of rules. More...

`#include <rbbi.h>`

Inheritance diagram for icu::RuleBasedBreakIterator:

## Public Member Functions
| RuleBasedBreakIterator ()
| Default constructor. More...
| RuleBasedBreakIterator (const RuleBasedBreakIterator &that)
| Copy constructor. More...
| RuleBasedBreakIterator (const UnicodeString &rules, UParseError &parseError, UErrorCode &status)
| Construct a RuleBasedBreakIterator from a set of rules supplied as a string. More...
| RuleBasedBreakIterator (const uint8_t *compiledRules, uint32_t ruleLength, UErrorCode &status)
| Contruct a RuleBasedBreakIterator from a set of precompiled binary rules. More...
| RuleBasedBreakIterator (UDataMemory *image, UErrorCode &status)
| This constructor uses the udata interface to create a BreakIterator whose internal tables live in a memory-mapped file. More...
virtual | ~RuleBasedBreakIterator ()
| Destructor. More...
RuleBasedBreakIterator & | operator= (const RuleBasedBreakIterator &that)
| Assignment operator. More...
virtual UBool | operator== (const BreakIterator &that) const
| Equality operator. More...
UBool | operator!= (const BreakIterator &that) const
| Not-equal operator. More...
virtual BreakIterator * | clone () const
| Returns a newly-constructed RuleBasedBreakIterator with the same behavior, and iterating over the same text, as this one. More...
virtual int32_t | hashCode (void) const
| Compute a hash code for this BreakIterator. More...
virtual const UnicodeString & | getRules (void) const
| Returns the description used to create this iterator. More...
virtual CharacterIterator & | getText (void) const
virtual UText * | getUText (UText *fillIn, UErrorCode &status) const
| Get a UText for the text being analyzed. More...
virtual void | adoptText (CharacterIterator *newText)
| Set the iterator to analyze a new piece of text. More...
virtual void | setText (const UnicodeString &newText)
| Set the iterator to analyze a new piece of text. More...
virtual void | setText (UText *text, UErrorCode &status)
| Reset the break iterator to operate over the text represented by the UText. More...
virtual int32_t | first (void)
| Sets the current iteration position to the beginning of the text, position zero. More...
virtual int32_t | last (void)
| Sets the current iteration position to the end of the text. More...
virtual int32_t | next (int32_t n)
| Advances the iterator either forward or backward the specified number of steps. More...
virtual int32_t | next (void)
| Advances the iterator to the next boundary position. More...
virtual int32_t | previous (void)
| Moves the iterator backwards, to the last boundary preceding this one. More...
virtual int32_t | following (int32_t offset)
| Sets the iterator to refer to the first boundary position following the specified position. More...
virtual int32_t | preceding (int32_t offset)
| Sets the iterator to refer to the last boundary position before the specified position. More...
virtual UBool | isBoundary (int32_t offset)
| Returns true if the specfied position is a boundary position. More...
virtual int32_t | current (void) const
| Returns the current iteration position. More...
virtual int32_t | getRuleStatus () const
| Return the status tag from the break rule that determined the most recently returned break position. More...
virtual int32_t | getRuleStatusVec (int32_t *fillInVec, int32_t capacity, UErrorCode &status)
| Get the status (tag) values from the break rule(s) that determined the most recently returned break position. More...
virtual UClassID | getDynamicClassID (void) const
| Returns a unique class ID POLYMORPHICALLY. More...
virtual BreakIterator * | createBufferClone (void *stackBuffer, int32_t &BufferSize, UErrorCode &status)
| Deprecated functionality. More...
virtual const uint8_t * | getBinaryRules (uint32_t &length)
| Return the binary form of compiled break rules, which can then be used to create a new break iterator at some time in the future. More...
virtual RuleBasedBreakIterator & | refreshInputText (UText *input, UErrorCode &status)
| Set the subject text string upon which the break iterator is operating without changing any other aspect of the matching state. More...
Public Member Functions inherited from icu::BreakIterator
virtual | ~BreakIterator ()
| destructor More...
UBool | operator!= (const BreakIterator &rhs) const
| Returns the complement of the result of operator==. More...
UBool | isBufferClone (void)
| Determine whether the BreakIterator was created in user memory by createBufferClone(), and thus should not be deleted. More...
Locale | getLocale (ULocDataLocaleType type, UErrorCode &status) const
| Returns the locale for this break iterator. More...
const char * | getLocaleID (ULocDataLocaleType type, UErrorCode &status) const
| Get the locale for this break iterator object. More...
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor. More...

## Static Public Member Functions
static UClassID | getStaticClassID (void)
| Returns the class ID for this class. More...
Static Public Member Functions inherited from icu::BreakIterator
static BreakIterator * | createWordInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for word-breaks using the given locale. More...
static BreakIterator * | createLineInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for line-breaks using specified locale. More...
static BreakIterator * | createCharacterInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for character-breaks using specified locale Returns an instance of a BreakIterator implementing character breaks. More...
static BreakIterator * | createSentenceInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for sentence-breaks using specified locale Returns an instance of a BreakIterator implementing sentence breaks. More...
static BreakIterator * | createTitleInstance (const Locale &where, UErrorCode &status)
| Create BreakIterator for title-casing breaks using the specified locale Returns an instance of a BreakIterator implementing title breaks. More...
static const Locale * | getAvailableLocales (int32_t &count)
| Get the set of Locales for which TextBoundaries are installed. More...
static UnicodeString & | getDisplayName (const Locale &objectLocale, const Locale &displayLocale, UnicodeString &name)
| Get name of the object for the desired Locale, in the desired langauge. More...
static UnicodeString & | getDisplayName (const Locale &objectLocale, UnicodeString &name)
| Get name of the object for the desired Locale, in the langauge of the default locale. More...
static URegistryKey | registerInstance (BreakIterator *toAdopt, const Locale &locale, UBreakIteratorType kind, UErrorCode &status)
| Register a new break iterator of the indicated kind, to use in the given locale. More...
static UBool | unregister (URegistryKey key, UErrorCode &status)
| Unregister a previously-registered BreakIterator using the key returned from the register call. More...
static StringEnumeration * | getAvailableLocales (void)
| Return a StringEnumeration over the locales available at the time of the call, including registered locales. More...

## Protected Types
enum | EDontAdopt { kDontAdopt }
| Constant to be used in the constructor RuleBasedBreakIterator(RBBIDataHeader*, EDontAdopt, UErrorCode &); which does not adopt the memory indicated by the RBBIDataHeader* parameter. More...

## Protected Member Functions
| RuleBasedBreakIterator (RBBIDataHeader *data, UErrorCode &status)
| Constructor from a flattened set of RBBI data in malloced memory. More...
| RuleBasedBreakIterator (const RBBIDataHeader *data, enum EDontAdopt dontAdopt, UErrorCode &status)
| Constructor from a flattened set of RBBI data in memory which need not be malloced (e.g. More...
virtual void | reset (void)
| Dumps caches and performs other actions associated with a complete change in text or iteration position. More...
virtual void | setBreakType (int32_t type)
| Set the type of the break iterator. More...
void | init ()
| Common initialization function, used by constructors and bufferClone. More...
int32_t | checkDictionary (int32_t startPos, int32_t endPos, UBool reverse)
| This is the function that actually implements dictionary-based breaking. More...
Protected Member Functions inherited from icu::BreakIterator
| BreakIterator ()
| BreakIterator (const BreakIterator &other)
| BreakIterator (const Locale &valid, const Locale &actual)

## Protected Attributes
UText * | fText
| The UText through which this BreakIterator accesses the text. More...
CharacterIterator * | fCharIter
| A character iterator that refers to the same text as the UText, above. More...
StringCharacterIterator * | fSCharIter
| When the input text is provided by a UnicodeString, this will point to a characterIterator that wraps that data. More...
UCharCharacterIterator * | fDCharIter
| When the input text is provided by a UText, this dummy CharacterIterator over an empty string will be returned from getText()
RBBIDataWrapper * | fData
| The rule data for this BreakIterator instance. More...
int32_t | fLastRuleStatusIndex
| Index of the Rule {tag} values for the most recent match. More...
UBool | fLastStatusIndexValid
| Rule tag value valid flag. More...
uint32_t | fDictionaryCharCount
| Counter for the number of characters encountered with the "dictionary" flag set. More...
int32_t * | fCachedBreakPositions
| When a range of characters is divided up using the dictionary, the break positions that are discovered are stored here, preventing us from having to use either the dictionary or the state table again until the iterator leaves this range of text. More...
int32_t | fNumCachedBreakPositions
| The number of elements in fCachedBreakPositions. More...
int32_t | fPositionInCache
| if fCachedBreakPositions is not null, this indicates which item in the cache the current iteration position refers to More...
UStack * | fLanguageBreakEngines
| If present, UStack of LanguageBreakEngine objects that might handle dictionary characters. More...
UnhandledEngine * | fUnhandledBreakEngine
| If present, the special LanguageBreakEngine used for handling characters that are in the dictionary set, but not handled by any LangugageBreakEngine. More...
int32_t | fBreakType
| The type of the break iterator, or -1 if it has not been set. More...

## Friends
class | RBBIRuleBuilder
class | BreakIterator

## Additional Inherited Members
Public Types inherited from icu::BreakIterator
enum | { DONE = (int32_t)-1 }

## Detailed Description

A subclass of BreakIterator whose behavior is specified using a list of rules.

Instances of this class are most commonly created by the factory methods of BreakIterator::createWordInstance(), BreakIterator::createLineInstance(), etc., and then used via the abstract API in class BreakIterator

See the ICU User Guide for information on Break Iterator Rules.

This class is not intended to be subclassed. (Class DictionaryBasedBreakIterator is a subclass, but that relationship is effectively internal to the ICU implementation. The subclassing interface to RulesBasedBreakIterator is not part of the ICU API, and may not remain stable.

Definition at line 65 of file rbbi.h.

## Member Enumeration Documentation

enum icu::RuleBasedBreakIterator::EDontAdopt
| protected

Constant to be used in the constructor RuleBasedBreakIterator(RBBIDataHeader*, EDontAdopt, UErrorCode &); which does not adopt the memory indicated by the RBBIDataHeader* parameter.

Internal:
  Do not use. This API is for internal use only.

Definition at line 182 of file rbbi.h.

## Constructor & Destructor Documentation

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | RBBIDataHeader * | data,
|  | UErrorCode & | status
| ) |  |
| protected

Constructor from a flattened set of RBBI data in malloced memory.

RulesBasedBreakIterators built from a custom set of rules are created via this constructor; the rules are compiled into memory, then the break iterator is constructed here.

The break iterator adopts the memory, and will free it when done.

Internal:
  Do not use. This API is for internal use only.

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const RBBIDataHeader * | data,
|  | enum EDontAdopt | dontAdopt,
|  | UErrorCode & | status
| ) |  |
| protected

Constructor from a flattened set of RBBI data in memory which need not be malloced (e.g.

it may be a memory-mapped file, etc.).

           This version does not adopt the memory, and does not
           free it when done.

Internal:
  Do not use. This API is for internal use only.

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( |  | ) |

Default constructor.

Creates an empty shell of an iterator, with no rules or text to iterate over. Object can subsequently be assigned to.

Stable:
  ICU 2.2

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const RuleBasedBreakIterator & | that | ) |

Copy constructor.

Will produce a break iterator with the same behavior, and which iterates over the same text, as the one passed in.

Parameters

  that | The RuleBasedBreakIterator passed to be copied

Stable:
  ICU 2.0

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const UnicodeString & | rules,
|  | UParseError & | parseError,
|  | UErrorCode & | status
| ) |  |

Construct a RuleBasedBreakIterator from a set of rules supplied as a string.

Parameters

  rules | The break rules to be used.
  parseError | In the event of a syntax error in the rules, provides the location within the rules of the problem.
  status | Information on any errors encountered.

Stable:
  ICU 2.2

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | const uint8_t * | compiledRules,
|  | uint32_t | ruleLength,
|  | UErrorCode & | status
| ) |  |

Contruct a RuleBasedBreakIterator from a set of precompiled binary rules.

Binary rules are obtained from RulesBasedBreakIterator::getBinaryRules(). Construction of a break iterator in this way is substantially faster than constuction from source rules.

Ownership of the storage containing the compiled rules remains with the caller of this function. The compiled rules must not be modified or deleted during the life of the break iterator.

The compiled rules are not compatible across different major versions of ICU. The compiled rules are comaptible only between machines with the same byte ordering (little or big endian) and the same base character set family (ASCII or EBCDIC).

See also
  getBinaryRules

Parameters

  compiledRules | A pointer to the compiled break rules to be used.
  ruleLength | The length of the compiled break rules, in bytes. This corresponds to the length value produced by getBinaryRules().
  status | Information on any errors encountered, including invalid binary rules.

Stable:
  ICU 4.8

icu::RuleBasedBreakIterator::RuleBasedBreakIterator | ( | UDataMemory * | image,
|  | UErrorCode & | status
| ) |  |

This constructor uses the udata interface to create a BreakIterator whose internal tables live in a memory-mapped file.

"image" is an ICU UDataMemory handle for the pre-compiled break iterator tables.

Parameters

  image | handle to the memory image for the break iterator data. Ownership of the UDataMemory handle passes to the Break Iterator, which will be responsible for closing it when it is no longer needed.
  status | Information on any errors encountered.

See also
  udata_open
  getBinaryRules

Stable:
  ICU 2.8

virtual icu::RuleBasedBreakIterator::~RuleBasedBreakIterator | ( |  | ) |
| virtual

Destructor.

Stable:
  ICU 2.0

## Member Function Documentation

virtual void icu::RuleBasedBreakIterator::adoptText | ( | CharacterIterator * | newText | ) |
| virtual

Set the iterator to analyze a new piece of text.

This function resets the current iteration position to the beginning of the text.

Parameters

  newText | An iterator over the text to analyze. The BreakIterator takes ownership of the character iterator. The caller MUST NOT delete it!

Stable:
  ICU 2.0

Implements icu::BreakIterator.

int32_t icu::RuleBasedBreakIterator::checkDictionary | ( | int32_t | startPos,
|  | int32_t | endPos,
|  | UBool | reverse
| ) |  |
| protected

This is the function that actually implements dictionary-based breaking.

Covering at least the range from startPos to endPos, it checks for dictionary characters, and if it finds them determines the appropriate object to deal with them. It may cache found breaks in fCachedBreakPositions as it goes. It may well also look at text outside the range startPos to endPos. If going forward, endPos is the normal Unicode break result, and if goind in reverse, startPos is the normal Unicode break result

Parameters

  startPos | The start position of a range of text
  endPos | The end position of a range of text
  reverse | The call is for the reverse direction

Internal:
  Do not use. This API is for internal use only.

virtual BreakIterator* icu::RuleBasedBreakIterator::clone | ( |  | ) | const
| virtual

Returns a newly-constructed RuleBasedBreakIterator with the same behavior, and iterating over the same text, as this one.

Differs from the copy constructor in that it is polymorphic, and will correctly clone (copy) a derived class. clone() is thread safe. Multiple threads may simultaeneously clone the same source break iterator.

Returns
  a newly-constructed RuleBasedBreakIterator

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual BreakIterator* icu::RuleBasedBreakIterator::createBufferClone | ( | void * | stackBuffer,
|  | int32_t & | BufferSize,
|  | UErrorCode & | status
| ) |  |
| virtual

Deprecated functionality.

Use clone() instead.

Create a clone (copy) of this break iterator in memory provided by the caller. The idea is to increase performance by avoiding a storage allocation. Use of this functoin is NOT RECOMMENDED. Performance gains are minimal, and correct buffer management is tricky. Use clone() instead.

Parameters

  stackBuffer | The pointer to the memory into which the cloned object should be placed. If NULL, allocate heap memory for the cloned object.
  BufferSize | The size of the buffer. If zero, return the required buffer size, but do not clone the object. If the size was too small (but not zero), allocate heap storage for the cloned object.
  status | Error status. U_SAFECLONE_ALLOCATED_WARNING will be returned if the the provided buffer was too small, and the clone was therefore put on the heap.

Returns
  Pointer to the clone object. This may differ from the stackBuffer address if the byte alignment of the stack buffer was not suitable or if the stackBuffer was too small to hold the clone.

Deprecated:
  ICU 52. Use clone() instead.

Implements icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::current | ( | void |  | ) | const
| virtual

Returns the current iteration position.

Returns
  The current iteration position.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::first | ( | void |  | ) |
| virtual

Sets the current iteration position to the beginning of the text, position zero.

Returns
  The offset of the beginning of the text, zero.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::following | ( | int32_t | offset | ) |
| virtual

Sets the iterator to refer to the first boundary position following the specified position.

Parameters

  offset | The position from which to begin searching for a break position.

Returns
  The position of the first break after the current position.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual const uint8_t* icu::RuleBasedBreakIterator::getBinaryRules | ( | uint32_t & | length | ) |
| virtual

Return the binary form of compiled break rules, which can then be used to create a new break iterator at some time in the future.

Creating a break iterator from pre-compiled rules is much faster than building one from the source form of the break rules.

The binary data can only be used with the same version of ICU and on the same platform type (processor endian-ness)

Parameters

  length | Returns the length of the binary data. (Out paramter.)

Returns
  A pointer to the binary (compiled) rule data. The storage belongs to the RulesBasedBreakIterator object, not the caller, and must not be modified or deleted.

Stable:
  ICU 4.8

virtual UClassID icu::RuleBasedBreakIterator::getDynamicClassID | ( | void |  | ) | const
| virtual

Returns a unique class ID POLYMORPHICALLY.

Pure virtual override. This method is to implement a simple version of RTTI, since not all C++ compilers support genuine RTTI. Polymorphic operator==() and clone() methods call this method.

Returns
  The class ID for this object. All objects of a given class have the same class ID. Objects of other classes have different class IDs.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual const UnicodeString& icu::RuleBasedBreakIterator::getRules | ( | void |  | ) | const
| virtual

Returns the description used to create this iterator.

Returns
  the description used to create this iterator

Stable:
  ICU 2.0

virtual int32_t icu::RuleBasedBreakIterator::getRuleStatus | ( |  | ) | const
| virtual

Return the status tag from the break rule that determined the most recently returned break position.

For break rules that do not specify a status, a default value of 0 is returned. If more than one break rule would cause a boundary to be located at some position in the text, the numerically largest of the applicable status values is returned.

Of the standard types of ICU break iterators, only word break and line break provide status values. The values are defined in the header file ubrk.h. For Word breaks, the status allows distinguishing between words that contain alphabetic letters, "words" that appear to be numbers, punctuation and spaces, words containing ideographic characters, and more. For Line Break, the status distinguishes between hard (mandatory) breaks and soft (potential) break positions.

`getRuleStatus()` can be called after obtaining a boundary position from `next()`, `previous()`, or any other break iterator functions that returns a boundary position.

When creating custom break rules, one is free to define whatever status values may be convenient for the application.

Note: this function is not thread safe. It should not have been declared const, and the const remains only for compatibility reasons. (The function is logically const, but not bit-wise const).

Returns
  the status from the break rule that determined the most recently returned break position.

See also
  UWordBreak

Stable:
  ICU 2.2

Reimplemented from icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::getRuleStatusVec | ( | int32_t * | fillInVec,
|  | int32_t | capacity,
|  | UErrorCode & | status
| ) |  |
| virtual

Get the status (tag) values from the break rule(s) that determined the most recently returned break position.

The returned status value(s) are stored into an array provided by the caller. The values are stored in sorted (ascending) order. If the capacity of the output array is insufficient to hold the data, the output will be truncated to the available length, and a U_BUFFER_OVERFLOW_ERROR will be signaled.

Parameters

  fillInVec | an array to be filled in with the status values.
  capacity | the length of the supplied vector. A length of zero causes the function to return the number of status values, in the normal way, without attemtping to store any values.
  status | receives error codes.

Returns
  The number of rule status values from rules that determined the most recent boundary returned by the break iterator. In the event of a U_BUFFER_OVERFLOW_ERROR, the return value is the total number of status values that were available, not the reduced number that were actually returned.

See also
  getRuleStatus

Stable:
  ICU 3.0

Reimplemented from icu::BreakIterator.

static UClassID icu::RuleBasedBreakIterator::getStaticClassID | ( | void |  | ) |
| static

Returns the class ID for this class.

This is useful only for comparing to a return value from getDynamicClassID(). For example:

     Base* polymorphic_pointer = createPolymorphicObject();
     if (polymorphic_pointer->getDynamicClassID() ==
         Derived::getStaticClassID()) ...

Returns
  The class ID for all objects of this class.

Stable:
  ICU 2.0

virtual CharacterIterator& icu::RuleBasedBreakIterator::getText | ( | void |  | ) | const
| virtual

Return a CharacterIterator over the text being analyzed. The returned character iterator is owned by the break iterator, and must not be deleted by the caller. Repeated calls to this function may return the same CharacterIterator.

The returned character iterator must not be used concurrently with the break iterator. If concurrent operation is needed, clone the returned character iterator first and operate on the clone.

When the break iterator is operating on text supplied via a UText, this function will fail. Lacking any way to signal failures, it returns an CharacterIterator containing no text. The function getUText() provides similar functionality, is reliable, and is more efficient.

TODO: deprecate this function?

Returns
  An iterator over the text being analyzed.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual UText* icu::RuleBasedBreakIterator::getUText | ( | UText * | fillIn,
|  | UErrorCode & | status
| ) |  | const
| virtual

Get a UText for the text being analyzed.

The returned UText is a shallow clone of the UText used internally by the break iterator implementation. It can safely be used to access the text without impacting any break iterator operations, but the underlying text itself must not be altered.

Parameters

  fillIn | A UText to be filled in. If NULL, a new UText will be allocated to hold the result.
  status | receives any error codes.

Returns
  The current UText for this break iterator. If an input UText was provided, it will always be returned.

Stable:
  ICU 3.4

Implements icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::hashCode | ( | void |  | ) | const
| virtual

Compute a hash code for this BreakIterator.

Returns
  A hash code

Stable:
  ICU 2.0

void icu::RuleBasedBreakIterator::init | ( |  | ) |
| protected

Common initialization function, used by constructors and bufferClone.

Internal:
  Do not use. This API is for internal use only.

virtual UBool icu::RuleBasedBreakIterator::isBoundary | ( | int32_t | offset | ) |
| virtual

Returns true if the specfied position is a boundary position.

As a side effect, leaves the iterator pointing to the first boundary position at or after "offset".

Parameters

  offset | the offset to check.

Returns
  True if "offset" is a boundary position.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::last | ( | void |  | ) |
| virtual

Sets the current iteration position to the end of the text.

Returns
  The text's past-the-end offset.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::next | ( | int32_t | n | ) |
| virtual

Advances the iterator either forward or backward the specified number of steps.

Negative values move backward, and positive values move forward. This is equivalent to repeatedly calling next() or previous().

Parameters

  n | The number of steps to move. The sign indicates the direction (negative is backwards, and positive is forwards).

Returns
  The character offset of the boundary position n boundaries away from the current one.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::next | ( | void |  | ) |
| virtual

Advances the iterator to the next boundary position.

Returns
  The position of the first boundary after this one.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

UBool icu::RuleBasedBreakIterator::operator!= | ( | const BreakIterator & | that | ) | const
| inline

Not-equal operator.

If operator== returns TRUE, this returns FALSE, and vice versa.

Parameters

  that | The BreakIterator to be compared for inequality

Returns
  TRUE if both BreakIterators are not same.

Stable:
  ICU 2.0

Definition at line 774 of file rbbi.h.

References icu::operator==().

RuleBasedBreakIterator& icu::RuleBasedBreakIterator::operator= | ( | const RuleBasedBreakIterator & | that | ) |

Assignment operator.

Sets this iterator to have the same behavior, and iterate over the same text, as the one passed in.

Parameters

  that | The RuleBasedBreakItertor passed in

Returns
  the newly created RuleBasedBreakIterator

Stable:
  ICU 2.0

virtual UBool icu::RuleBasedBreakIterator::operator== | ( | const BreakIterator & | that | ) | const
| virtual

Equality operator.

Returns TRUE if both BreakIterators are of the same class, have the same behavior, and iterate over the same text.

Parameters

  that | The BreakIterator to be compared for equality

Returns
  TRUE if both BreakIterators are of the same class, have the same behavior, and iterate over the same text.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::preceding | ( | int32_t | offset | ) |
| virtual

Sets the iterator to refer to the last boundary position before the specified position.

Parameters

  offset | The position to begin searching for a break from.

Returns
  The position of the last boundary before the starting position.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual int32_t icu::RuleBasedBreakIterator::previous | ( | void |  | ) |
| virtual

Moves the iterator backwards, to the last boundary preceding this one.

Returns
  The position of the last boundary position preceding this one.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual RuleBasedBreakIterator& icu::RuleBasedBreakIterator::refreshInputText | ( | UText * | input,
|  | UErrorCode & | status
| ) |  |
| virtual

Set the subject text string upon which the break iterator is operating without changing any other aspect of the matching state.

The new and previous text strings must have the same content.

This function is intended for use in environments where ICU is operating on strings that may move around in memory. It provides a mechanism for notifying ICU that the string has been relocated, and providing a new UText to access the string in its new position.

Note that the break iterator implementation never copies the underlying text of a string being processed, but always operates directly on the original text provided by the user. Refreshing simply drops the references to the old text and replaces them with references to the new.

Caution: this function is normally used only by very specialized, system-level code. One example use case is with garbage collection that moves the text in memory.

Parameters

  input | The new (moved) text string.
  status | Receives errors detected by this function.

Returns
  *this

Stable:
  ICU 49

Implements icu::BreakIterator.

virtual void icu::RuleBasedBreakIterator::reset | ( | void |  | ) |
| protectedvirtual

Dumps caches and performs other actions associated with a complete change in text or iteration position.

Internal:
  Do not use. This API is for internal use only.

virtual void icu::RuleBasedBreakIterator::setBreakType | ( | int32_t | type | ) |
| protectedvirtual

Set the type of the break iterator.

Internal:
  Do not use. This API is for internal use only.

virtual void icu::RuleBasedBreakIterator::setText | ( | const UnicodeString & | newText | ) |
| virtual

Set the iterator to analyze a new piece of text.

This function resets the current iteration position to the beginning of the text.

Parameters

  newText | The text to analyze.

Stable:
  ICU 2.0

Implements icu::BreakIterator.

virtual void icu::RuleBasedBreakIterator::setText | ( | UText * | text,
|  | UErrorCode & | status
| ) |  |
| virtual

Reset the break iterator to operate over the text represented by the UText.

The iterator position is reset to the start.

This function makes a shallow clone of the supplied UText. This means that the caller is free to immediately close or otherwise reuse the Utext that was passed as a parameter, but that the underlying text itself must not be altered while being referenced by the break iterator.

Parameters

  text | The UText used to change the text.
  status | Receives any error codes.

Stable:
  ICU 3.4

Implements icu::BreakIterator.

## Friends And Related Function Documentation

friend class BreakIterator
| friend

Internal:
  Do not use. This API is for internal use only.

Definition at line 212 of file rbbi.h.

## Field Documentation

int32_t icu::RuleBasedBreakIterator::fBreakType
| protected

The type of the break iterator, or -1 if it has not been set.

Internal:
  Do not use. This API is for internal use only.

Definition at line 166 of file rbbi.h.

int32_t* icu::RuleBasedBreakIterator::fCachedBreakPositions
| protected

When a range of characters is divided up using the dictionary, the break positions that are discovered are stored here, preventing us from having to use either the dictionary or the state table again until the iterator leaves this range of text.

Has the most impact for line breaking.

Internal:
  Do not use. This API is for internal use only.

Definition at line 128 of file rbbi.h.

CharacterIterator* icu::RuleBasedBreakIterator::fCharIter
| protected

A character iterator that refers to the same text as the UText, above.

Only included for compatibility with old API, which was based on CharacterIterators. Value may be adopted from outside, or one of fSCharIter or fDCharIter, below.

Definition at line 79 of file rbbi.h.

RBBIDataWrapper* icu::RuleBasedBreakIterator::fData
| protected

The rule data for this BreakIterator instance.

Internal:
  Do not use. This API is for internal use only.

Definition at line 99 of file rbbi.h.

uint32_t icu::RuleBasedBreakIterator::fDictionaryCharCount
| protected

Counter for the number of characters encountered with the "dictionary" flag set.

Internal:
  Do not use. This API is for internal use only.

Definition at line 119 of file rbbi.h.

UStack* icu::RuleBasedBreakIterator::fLanguageBreakEngines
| protected

If present, UStack of LanguageBreakEngine objects that might handle dictionary characters.

Searched from top to bottom to find an object to handle a given character.

Internal:
  Do not use. This API is for internal use only.

Definition at line 150 of file rbbi.h.

int32_t icu::RuleBasedBreakIterator::fLastRuleStatusIndex
| protected

Index of the Rule {tag} values for the most recent match.

Internal:
  Do not use. This API is for internal use only.

Definition at line 104 of file rbbi.h.

UBool icu::RuleBasedBreakIterator::fLastStatusIndexValid
| protected

Rule tag value valid flag.

Some iterator operations don't intrinsically set the correct tag value. This flag lets us lazily compute the value if we are ever asked for it.

Internal:
  Do not use. This API is for internal use only.

Definition at line 112 of file rbbi.h.

int32_t icu::RuleBasedBreakIterator::fNumCachedBreakPositions
| protected

The number of elements in fCachedBreakPositions.

Internal:
  Do not use. This API is for internal use only.

Definition at line 134 of file rbbi.h.

int32_t icu::RuleBasedBreakIterator::fPositionInCache
| protected

if fCachedBreakPositions is not null, this indicates which item in the cache the current iteration position refers to

Internal:
  Do not use. This API is for internal use only.

Definition at line 141 of file rbbi.h.

StringCharacterIterator* icu::RuleBasedBreakIterator::fSCharIter
| protected

When the input text is provided by a UnicodeString, this will point to a characterIterator that wraps that data.

Needed only for the implementation of getText(), a backwards compatibility issue.

Definition at line 86 of file rbbi.h.

UText* icu::RuleBasedBreakIterator::fText
| protected

The UText through which this BreakIterator accesses the text.

Internal:
  Do not use. This API is for internal use only.

Definition at line 72 of file rbbi.h.

UnhandledEngine* icu::RuleBasedBreakIterator::fUnhandledBreakEngine
| protected

If present, the special LanguageBreakEngine used for handling characters that are in the dictionary set, but not handled by any LangugageBreakEngine.

Internal:
  Do not use. This API is for internal use only.

Definition at line 159 of file rbbi.h.

The documentation for this class was generated from the following file:

- rbbi.h